package com.maddyhome.idea.color.search;

/*
 * Color Browser - Color browser plugin for IDEA
 * Copyright (C) 2006 Rick Maddy. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import org.jetbrains.annotations.NotNull;

import java.awt.Color;
import java.util.Map;
import java.util.TreeMap;

public class SearchResults
{
    public SearchResults(@NotNull Object label)
    {
        this.label = label;
    }

    @NotNull
    public Object getLabel()
    {
        return label;
    }

    public void addColor(@NotNull Color color)
    {
        colors.put(color.getRGB(), color);
    }

    @NotNull
    public Map<Integer, Color> getColors()
    {
        return colors;
    }

    private Object label;
    private Map<Integer, Color> colors = new TreeMap<Integer, Color>();
}