package com.maddyhome.idea.color.util;

/*
 * Color Browser - Color browser plugin for IDEA
 * Copyright (C) 2006 Rick Maddy. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

public class MatchRange
{
    public MatchRange(int startOffset, int endOffset, String url)
    {
        this.startOffset = startOffset;
        this.endOffset = endOffset;
        this.match = url;
    }

    public int getStartOffset()
    {
        return startOffset;
    }

    public int getEndOffset()
    {
        return endOffset;
    }

    public String getMatch()
    {
        return match;
    }

    public boolean equals(Object o)
    {
        if (this == o)
        {
            return true;
        }
        if (o == null || getClass() != o.getClass())
        {
            return false;
        }

        final MatchRange that = (MatchRange)o;

        if (endOffset != that.endOffset)
        {
            return false;
        }
        if (startOffset != that.startOffset)
        {
            return false;
        }

        return match.equals(that.match);
    }

    public int hashCode()
    {
        int result;
        result = startOffset;
        result = 29 * result + endOffset;
        result = 29 * result + match.hashCode();
        return result;
    }

    private int startOffset;
    private int endOffset;
    private String match;
}